/* delegate.c generated by valac, the Vala compiler
 * generated from delegate.vala, do not modify */

/* delegate.vala
 *
 * Copyright (C) 2008-2011  Florian Brosch
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Florian Brosch <flo.brosch@gmail.com>
 */


#include <glib.h>
#include <glib-object.h>
#include "valadoc.h"
#include <stdlib.h>
#include <string.h>
#include <valagee.h>

enum  {
	VALADOC_API_DELEGATE_0_PROPERTY,
	VALADOC_API_DELEGATE_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY,
	VALADOC_API_DELEGATE_RETURN_TYPE_PROPERTY,
	VALADOC_API_DELEGATE_NODE_TYPE_PROPERTY,
	VALADOC_API_DELEGATE_IS_STATIC_PROPERTY,
	VALADOC_API_DELEGATE_NUM_PROPERTIES
};
static GParamSpec* valadoc_api_delegate_properties[VALADOC_API_DELEGATE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _valadoc_api_signature_builder_unref0(var) ((var == NULL) ? NULL : (var = (valadoc_api_signature_builder_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

struct _ValadocApiDelegatePrivate {
	gchar* cname;
	gchar* _implicit_array_length_cparameter_name;
	ValadocApiTypeReference* _return_type;
	gboolean _is_static;
};


static gpointer valadoc_api_delegate_parent_class = NULL;
static ValadocApiCallableIface * valadoc_api_delegate_valadoc_api_callable_parent_iface = NULL;

#define VALADOC_API_DELEGATE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALADOC_API_TYPE_DELEGATE, ValadocApiDelegatePrivate))
static void valadoc_api_delegate_set_is_static (ValadocApiDelegate* self,
                                         gboolean value);
static void valadoc_api_delegate_real_accept (ValadocApiNode* base,
                                       ValadocApiVisitor* visitor);
static ValadocContentInline* valadoc_api_delegate_real_build_signature (ValadocApiItem* base);
G_GNUC_INTERNAL const gchar* valadoc_api_callable_get_implicit_array_length_cparameter_name (ValadocApiCallable* self);
G_GNUC_INTERNAL void valadoc_api_callable_set_implicit_array_length_cparameter_name (ValadocApiCallable* self,
                                                                     const gchar* value);
static void valadoc_api_delegate_finalize (GObject * obj);
static void _vala_valadoc_api_delegate_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_valadoc_api_delegate_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);


ValadocApiDelegate*
valadoc_api_delegate_construct (GType object_type,
                                ValadocApiNode* parent,
                                ValadocApiSourceFile* file,
                                const gchar* name,
                                ValadocApiSymbolAccessibility accessibility,
                                ValadocApiSourceComment* comment,
                                const gchar* cname,
                                gboolean is_static,
                                void* data)
{
	ValadocApiDelegate * self = NULL;
	gchar* _tmp0_;
	g_return_val_if_fail (parent != NULL, NULL);
	g_return_val_if_fail (file != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	self = (ValadocApiDelegate*) valadoc_api_typesymbol_construct (object_type, parent, file, name, accessibility, comment, NULL, NULL, NULL, NULL, FALSE, data);
	valadoc_api_delegate_set_is_static (self, is_static);
	_tmp0_ = g_strdup (cname);
	_g_free0 (self->priv->cname);
	self->priv->cname = _tmp0_;
	return self;
}


ValadocApiDelegate*
valadoc_api_delegate_new (ValadocApiNode* parent,
                          ValadocApiSourceFile* file,
                          const gchar* name,
                          ValadocApiSymbolAccessibility accessibility,
                          ValadocApiSourceComment* comment,
                          const gchar* cname,
                          gboolean is_static,
                          void* data)
{
	return valadoc_api_delegate_construct (VALADOC_API_TYPE_DELEGATE, parent, file, name, accessibility, comment, cname, is_static, data);
}


/**
 * Returns the name of this delegate as it is used in C.
 */
gchar*
valadoc_api_delegate_get_cname (ValadocApiDelegate* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->cname;
	_tmp1_ = g_strdup (_tmp0_);
	result = _tmp1_;
	return result;
}


/**
 * {@inheritDoc}
 */
static void
valadoc_api_delegate_real_accept (ValadocApiNode* base,
                                  ValadocApiVisitor* visitor)
{
	ValadocApiDelegate * self;
	self = (ValadocApiDelegate*) base;
	g_return_if_fail (visitor != NULL);
	valadoc_api_visitor_visit_delegate (visitor, self);
}


/**
 * {@inheritDoc}
 */
static gpointer
_vala_iterable_ref0 (gpointer self)
{
	return self ? vala_iterable_ref (self) : NULL;
}


static ValadocContentInline*
valadoc_api_delegate_real_build_signature (ValadocApiItem* base)
{
	ValadocApiDelegate * self;
	ValadocContentInline* result = NULL;
	ValadocApiSignatureBuilder* signature = NULL;
	ValadocApiSignatureBuilder* _tmp0_;
	ValadocApiSignatureBuilder* _tmp1_;
	ValadocApiSymbolAccessibility _tmp2_;
	ValadocApiSymbolAccessibility _tmp3_;
	const gchar* _tmp4_;
	ValadocApiSignatureBuilder* _tmp5_;
	ValadocApiSignatureBuilder* _tmp6_;
	ValadocApiSignatureBuilder* _tmp7_;
	ValadocApiSignatureBuilder* _tmp8_;
	ValadocApiSignatureBuilder* _tmp9_;
	ValadocApiSignatureBuilder* _tmp10_;
	ValadocApiTypeReference* _tmp11_;
	ValadocApiTypeReference* _tmp12_;
	ValadocContentInline* _tmp13_;
	ValadocContentInline* _tmp14_;
	ValadocApiSignatureBuilder* _tmp15_;
	ValadocApiSignatureBuilder* _tmp16_;
	ValadocApiSignatureBuilder* _tmp17_;
	ValadocApiSignatureBuilder* _tmp18_;
	ValadocApiSignatureBuilder* _tmp19_;
	ValaList* type_parameters = NULL;
	ValaList* _tmp20_;
	ValaList* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	ValadocApiSignatureBuilder* _tmp50_;
	ValadocApiSignatureBuilder* _tmp51_;
	ValadocApiSignatureBuilder* _tmp52_;
	gboolean first = FALSE;
	ValadocApiSignatureBuilder* _tmp73_;
	ValadocApiSignatureBuilder* _tmp74_;
	ValadocApiSignatureBuilder* _tmp75_;
	ValaList* exceptions = NULL;
	ValadocApiNodeType* _tmp76_;
	ValadocApiNodeType* _tmp77_;
	gint _tmp77__length1;
	ValaList* _tmp78_;
	ValaList* _tmp79_;
	ValaList* _tmp80_;
	gint _tmp81_;
	gint _tmp82_;
	ValadocApiSignatureBuilder* _tmp104_;
	ValadocContentRun* _tmp105_;
	self = (ValadocApiDelegate*) base;
	_tmp0_ = valadoc_api_signature_builder_new ();
	signature = _tmp0_;
	_tmp1_ = signature;
	_tmp2_ = valadoc_api_symbol_get_accessibility ((ValadocApiSymbol*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = valadoc_api_symbol_accessibility_to_string (_tmp3_);
	_tmp5_ = valadoc_api_signature_builder_append_keyword (_tmp1_, _tmp4_, TRUE);
	_tmp6_ = _tmp5_;
	_valadoc_api_signature_builder_unref0 (_tmp6_);
	_tmp7_ = signature;
	_tmp8_ = valadoc_api_signature_builder_append_keyword (_tmp7_, "delegate", TRUE);
	_tmp9_ = _tmp8_;
	_valadoc_api_signature_builder_unref0 (_tmp9_);
	_tmp10_ = signature;
	_tmp11_ = valadoc_api_callable_get_return_type ((ValadocApiCallable*) self);
	_tmp12_ = _tmp11_;
	_tmp13_ = valadoc_api_item_get_signature ((ValadocApiItem*) _tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = valadoc_api_signature_builder_append_content (_tmp10_, _tmp14_, TRUE);
	_tmp16_ = _tmp15_;
	_valadoc_api_signature_builder_unref0 (_tmp16_);
	_tmp17_ = signature;
	_tmp18_ = valadoc_api_signature_builder_append_symbol (_tmp17_, (ValadocApiNode*) self, TRUE);
	_tmp19_ = _tmp18_;
	_valadoc_api_signature_builder_unref0 (_tmp19_);
	_tmp20_ = valadoc_api_node_get_children_by_type ((ValadocApiNode*) self, VALADOC_API_NODE_TYPE_TYPE_PARAMETER, FALSE);
	type_parameters = _tmp20_;
	_tmp21_ = type_parameters;
	_tmp22_ = vala_collection_get_size ((ValaCollection*) _tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_ > 0) {
		ValadocApiSignatureBuilder* _tmp24_;
		ValadocApiSignatureBuilder* _tmp25_;
		ValadocApiSignatureBuilder* _tmp26_;
		gboolean first = FALSE;
		ValadocApiSignatureBuilder* _tmp47_;
		ValadocApiSignatureBuilder* _tmp48_;
		ValadocApiSignatureBuilder* _tmp49_;
		_tmp24_ = signature;
		_tmp25_ = valadoc_api_signature_builder_append (_tmp24_, "<", FALSE);
		_tmp26_ = _tmp25_;
		_valadoc_api_signature_builder_unref0 (_tmp26_);
		first = TRUE;
		{
			ValaList* _param_list = NULL;
			ValaList* _tmp27_;
			ValaList* _tmp28_;
			gint _param_size = 0;
			ValaList* _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
			gint _param_index = 0;
			_tmp27_ = type_parameters;
			_tmp28_ = _vala_iterable_ref0 (_tmp27_);
			_param_list = _tmp28_;
			_tmp29_ = _param_list;
			_tmp30_ = vala_collection_get_size ((ValaCollection*) _tmp29_);
			_tmp31_ = _tmp30_;
			_param_size = _tmp31_;
			_param_index = -1;
			while (TRUE) {
				gint _tmp32_;
				gint _tmp33_;
				ValadocApiItem* param = NULL;
				ValaList* _tmp34_;
				gint _tmp35_;
				gpointer _tmp36_;
				gboolean _tmp37_;
				ValadocApiSignatureBuilder* _tmp41_;
				ValadocApiItem* _tmp42_;
				ValadocContentInline* _tmp43_;
				ValadocContentInline* _tmp44_;
				ValadocApiSignatureBuilder* _tmp45_;
				ValadocApiSignatureBuilder* _tmp46_;
				_param_index = _param_index + 1;
				_tmp32_ = _param_index;
				_tmp33_ = _param_size;
				if (!(_tmp32_ < _tmp33_)) {
					break;
				}
				_tmp34_ = _param_list;
				_tmp35_ = _param_index;
				_tmp36_ = vala_list_get (_tmp34_, _tmp35_);
				param = (ValadocApiItem*) ((ValadocApiNode*) _tmp36_);
				_tmp37_ = first;
				if (!_tmp37_) {
					ValadocApiSignatureBuilder* _tmp38_;
					ValadocApiSignatureBuilder* _tmp39_;
					ValadocApiSignatureBuilder* _tmp40_;
					_tmp38_ = signature;
					_tmp39_ = valadoc_api_signature_builder_append (_tmp38_, ",", FALSE);
					_tmp40_ = _tmp39_;
					_valadoc_api_signature_builder_unref0 (_tmp40_);
				}
				_tmp41_ = signature;
				_tmp42_ = param;
				_tmp43_ = valadoc_api_item_get_signature (_tmp42_);
				_tmp44_ = _tmp43_;
				_tmp45_ = valadoc_api_signature_builder_append_content (_tmp41_, _tmp44_, FALSE);
				_tmp46_ = _tmp45_;
				_valadoc_api_signature_builder_unref0 (_tmp46_);
				first = FALSE;
				_g_object_unref0 (param);
			}
			_vala_iterable_unref0 (_param_list);
		}
		_tmp47_ = signature;
		_tmp48_ = valadoc_api_signature_builder_append (_tmp47_, ">", FALSE);
		_tmp49_ = _tmp48_;
		_valadoc_api_signature_builder_unref0 (_tmp49_);
	}
	_tmp50_ = signature;
	_tmp51_ = valadoc_api_signature_builder_append (_tmp50_, "(", TRUE);
	_tmp52_ = _tmp51_;
	_valadoc_api_signature_builder_unref0 (_tmp52_);
	first = TRUE;
	{
		ValaList* _param_list = NULL;
		ValaList* _tmp53_;
		gint _param_size = 0;
		ValaList* _tmp54_;
		gint _tmp55_;
		gint _tmp56_;
		gint _param_index = 0;
		_tmp53_ = valadoc_api_node_get_children_by_type ((ValadocApiNode*) self, VALADOC_API_NODE_TYPE_FORMAL_PARAMETER, FALSE);
		_param_list = _tmp53_;
		_tmp54_ = _param_list;
		_tmp55_ = vala_collection_get_size ((ValaCollection*) _tmp54_);
		_tmp56_ = _tmp55_;
		_param_size = _tmp56_;
		_param_index = -1;
		while (TRUE) {
			gint _tmp57_;
			gint _tmp58_;
			ValadocApiNode* param = NULL;
			ValaList* _tmp59_;
			gint _tmp60_;
			gpointer _tmp61_;
			gboolean _tmp62_;
			ValadocApiSignatureBuilder* _tmp66_;
			ValadocApiNode* _tmp67_;
			ValadocContentInline* _tmp68_;
			ValadocContentInline* _tmp69_;
			gboolean _tmp70_;
			ValadocApiSignatureBuilder* _tmp71_;
			ValadocApiSignatureBuilder* _tmp72_;
			_param_index = _param_index + 1;
			_tmp57_ = _param_index;
			_tmp58_ = _param_size;
			if (!(_tmp57_ < _tmp58_)) {
				break;
			}
			_tmp59_ = _param_list;
			_tmp60_ = _param_index;
			_tmp61_ = vala_list_get (_tmp59_, _tmp60_);
			param = (ValadocApiNode*) _tmp61_;
			_tmp62_ = first;
			if (!_tmp62_) {
				ValadocApiSignatureBuilder* _tmp63_;
				ValadocApiSignatureBuilder* _tmp64_;
				ValadocApiSignatureBuilder* _tmp65_;
				_tmp63_ = signature;
				_tmp64_ = valadoc_api_signature_builder_append (_tmp63_, ",", FALSE);
				_tmp65_ = _tmp64_;
				_valadoc_api_signature_builder_unref0 (_tmp65_);
			}
			_tmp66_ = signature;
			_tmp67_ = param;
			_tmp68_ = valadoc_api_item_get_signature ((ValadocApiItem*) _tmp67_);
			_tmp69_ = _tmp68_;
			_tmp70_ = first;
			_tmp71_ = valadoc_api_signature_builder_append_content (_tmp66_, _tmp69_, !_tmp70_);
			_tmp72_ = _tmp71_;
			_valadoc_api_signature_builder_unref0 (_tmp72_);
			first = FALSE;
			_g_object_unref0 (param);
		}
		_vala_iterable_unref0 (_param_list);
	}
	_tmp73_ = signature;
	_tmp74_ = valadoc_api_signature_builder_append (_tmp73_, ")", FALSE);
	_tmp75_ = _tmp74_;
	_valadoc_api_signature_builder_unref0 (_tmp75_);
	_tmp76_ = g_new0 (ValadocApiNodeType, 2);
	_tmp76_[0] = VALADOC_API_NODE_TYPE_ERROR_DOMAIN;
	_tmp76_[1] = VALADOC_API_NODE_TYPE_CLASS;
	_tmp77_ = _tmp76_;
	_tmp77__length1 = 2;
	_tmp78_ = valadoc_api_node_get_children_by_types ((ValadocApiNode*) self, _tmp77_, 2, TRUE);
	_tmp79_ = _tmp78_;
	_tmp77_ = (g_free (_tmp77_), NULL);
	exceptions = _tmp79_;
	_tmp80_ = exceptions;
	_tmp81_ = vala_collection_get_size ((ValaCollection*) _tmp80_);
	_tmp82_ = _tmp81_;
	if (_tmp82_ > 0) {
		ValadocApiSignatureBuilder* _tmp83_;
		ValadocApiSignatureBuilder* _tmp84_;
		ValadocApiSignatureBuilder* _tmp85_;
		_tmp83_ = signature;
		_tmp84_ = valadoc_api_signature_builder_append_keyword (_tmp83_, "throws", TRUE);
		_tmp85_ = _tmp84_;
		_valadoc_api_signature_builder_unref0 (_tmp85_);
		first = TRUE;
		{
			ValaList* _param_list = NULL;
			ValaList* _tmp86_;
			ValaList* _tmp87_;
			gint _param_size = 0;
			ValaList* _tmp88_;
			gint _tmp89_;
			gint _tmp90_;
			gint _param_index = 0;
			_tmp86_ = exceptions;
			_tmp87_ = _vala_iterable_ref0 (_tmp86_);
			_param_list = _tmp87_;
			_tmp88_ = _param_list;
			_tmp89_ = vala_collection_get_size ((ValaCollection*) _tmp88_);
			_tmp90_ = _tmp89_;
			_param_size = _tmp90_;
			_param_index = -1;
			while (TRUE) {
				gint _tmp91_;
				gint _tmp92_;
				ValadocApiNode* param = NULL;
				ValaList* _tmp93_;
				gint _tmp94_;
				gpointer _tmp95_;
				gboolean _tmp96_;
				ValadocApiSignatureBuilder* _tmp100_;
				ValadocApiNode* _tmp101_;
				ValadocApiSignatureBuilder* _tmp102_;
				ValadocApiSignatureBuilder* _tmp103_;
				_param_index = _param_index + 1;
				_tmp91_ = _param_index;
				_tmp92_ = _param_size;
				if (!(_tmp91_ < _tmp92_)) {
					break;
				}
				_tmp93_ = _param_list;
				_tmp94_ = _param_index;
				_tmp95_ = vala_list_get (_tmp93_, _tmp94_);
				param = (ValadocApiNode*) _tmp95_;
				_tmp96_ = first;
				if (!_tmp96_) {
					ValadocApiSignatureBuilder* _tmp97_;
					ValadocApiSignatureBuilder* _tmp98_;
					ValadocApiSignatureBuilder* _tmp99_;
					_tmp97_ = signature;
					_tmp98_ = valadoc_api_signature_builder_append (_tmp97_, ",", FALSE);
					_tmp99_ = _tmp98_;
					_valadoc_api_signature_builder_unref0 (_tmp99_);
				}
				_tmp100_ = signature;
				_tmp101_ = param;
				_tmp102_ = valadoc_api_signature_builder_append_type (_tmp100_, _tmp101_, TRUE);
				_tmp103_ = _tmp102_;
				_valadoc_api_signature_builder_unref0 (_tmp103_);
				first = FALSE;
				_g_object_unref0 (param);
			}
			_vala_iterable_unref0 (_param_list);
		}
	}
	_tmp104_ = signature;
	_tmp105_ = valadoc_api_signature_builder_get (_tmp104_);
	result = (ValadocContentInline*) _tmp105_;
	_vala_iterable_unref0 (exceptions);
	_vala_iterable_unref0 (type_parameters);
	_valadoc_api_signature_builder_unref0 (signature);
	return result;
}


static const gchar*
valadoc_api_delegate_real_get_implicit_array_length_cparameter_name (ValadocApiCallable* base)
{
	const gchar* result;
	ValadocApiDelegate* self;
	const gchar* _tmp0_;
	self = (ValadocApiDelegate*) base;
	_tmp0_ = self->priv->_implicit_array_length_cparameter_name;
	result = _tmp0_;
	return result;
}


static void
valadoc_api_delegate_real_set_implicit_array_length_cparameter_name (ValadocApiCallable* base,
                                                                     const gchar* value)
{
	ValadocApiDelegate* self;
	gchar* old_value;
	self = (ValadocApiDelegate*) base;
	old_value = valadoc_api_delegate_real_get_implicit_array_length_cparameter_name (base);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_implicit_array_length_cparameter_name);
		self->priv->_implicit_array_length_cparameter_name = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_delegate_properties[VALADOC_API_DELEGATE_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY]);
	}
}


static ValadocApiTypeReference*
valadoc_api_delegate_real_get_return_type (ValadocApiCallable* base)
{
	ValadocApiTypeReference* result;
	ValadocApiDelegate* self;
	ValadocApiTypeReference* _tmp0_;
	self = (ValadocApiDelegate*) base;
	_tmp0_ = self->priv->_return_type;
	result = _tmp0_;
	return result;
}


static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}


static void
valadoc_api_delegate_real_set_return_type (ValadocApiCallable* base,
                                           ValadocApiTypeReference* value)
{
	ValadocApiDelegate* self;
	ValadocApiTypeReference* old_value;
	self = (ValadocApiDelegate*) base;
	old_value = valadoc_api_delegate_real_get_return_type (base);
	if (old_value != value) {
		ValadocApiTypeReference* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_return_type);
		self->priv->_return_type = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_delegate_properties[VALADOC_API_DELEGATE_RETURN_TYPE_PROPERTY]);
	}
}


static ValadocApiNodeType
valadoc_api_delegate_real_get_node_type (ValadocApiNode* base)
{
	ValadocApiNodeType result;
	ValadocApiDelegate* self;
	self = (ValadocApiDelegate*) base;
	result = VALADOC_API_NODE_TYPE_DELEGATE;
	return result;
}


gboolean
valadoc_api_delegate_get_is_static (ValadocApiDelegate* self)
{
	gboolean result;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->_is_static;
	result = _tmp0_;
	return result;
}


static void
valadoc_api_delegate_set_is_static (ValadocApiDelegate* self,
                                    gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = valadoc_api_delegate_get_is_static (self);
	if (old_value != value) {
		self->priv->_is_static = value;
		g_object_notify_by_pspec ((GObject *) self, valadoc_api_delegate_properties[VALADOC_API_DELEGATE_IS_STATIC_PROPERTY]);
	}
}


static void
valadoc_api_delegate_class_init (ValadocApiDelegateClass * klass)
{
	valadoc_api_delegate_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (ValadocApiDelegatePrivate));
	((ValadocApiNodeClass *) klass)->accept = (void (*) (ValadocApiNode*, ValadocApiVisitor*)) valadoc_api_delegate_real_accept;
	((ValadocApiItemClass *) klass)->build_signature = (ValadocContentInline* (*) (ValadocApiItem*)) valadoc_api_delegate_real_build_signature;
	VALADOC_API_NODE_CLASS (klass)->get_node_type = valadoc_api_delegate_real_get_node_type;
	G_OBJECT_CLASS (klass)->get_property = _vala_valadoc_api_delegate_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_valadoc_api_delegate_set_property;
	G_OBJECT_CLASS (klass)->finalize = valadoc_api_delegate_finalize;
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_DELEGATE_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY, valadoc_api_delegate_properties[VALADOC_API_DELEGATE_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY] = g_param_spec_string ("implicit-array-length-cparameter-name", "implicit-array-length-cparameter-name", "implicit-array-length-cparameter-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_DELEGATE_RETURN_TYPE_PROPERTY, valadoc_api_delegate_properties[VALADOC_API_DELEGATE_RETURN_TYPE_PROPERTY] = g_param_spec_object ("return-type", "return-type", "return-type", VALADOC_API_TYPE_TYPEREFERENCE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/**
	 * {@inheritDoc}
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_DELEGATE_NODE_TYPE_PROPERTY, valadoc_api_delegate_properties[VALADOC_API_DELEGATE_NODE_TYPE_PROPERTY] = g_param_spec_enum ("node-type", "node-type", "node-type", VALADOC_API_TYPE_NODE_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	/**
	 * Specifies whether this delegate is static
	 */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VALADOC_API_DELEGATE_IS_STATIC_PROPERTY, valadoc_api_delegate_properties[VALADOC_API_DELEGATE_IS_STATIC_PROPERTY] = g_param_spec_boolean ("is-static", "is-static", "is-static", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
}


static void
valadoc_api_delegate_valadoc_api_callable_interface_init (ValadocApiCallableIface * iface)
{
	valadoc_api_delegate_valadoc_api_callable_parent_iface = g_type_interface_peek_parent (iface);
	iface->get_implicit_array_length_cparameter_name = valadoc_api_delegate_real_get_implicit_array_length_cparameter_name;
	iface->set_implicit_array_length_cparameter_name = valadoc_api_delegate_real_set_implicit_array_length_cparameter_name;
	iface->get_return_type = valadoc_api_delegate_real_get_return_type;
	iface->set_return_type = valadoc_api_delegate_real_set_return_type;
}


static void
valadoc_api_delegate_instance_init (ValadocApiDelegate * self)
{
	self->priv = VALADOC_API_DELEGATE_GET_PRIVATE (self);
}


static void
valadoc_api_delegate_finalize (GObject * obj)
{
	ValadocApiDelegate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALADOC_API_TYPE_DELEGATE, ValadocApiDelegate);
	_g_free0 (self->priv->cname);
	_g_free0 (self->priv->_implicit_array_length_cparameter_name);
	_g_object_unref0 (self->priv->_return_type);
	G_OBJECT_CLASS (valadoc_api_delegate_parent_class)->finalize (obj);
}


/**
 * Represents a Delegate.
 */
GType
valadoc_api_delegate_get_type (void)
{
	static volatile gsize valadoc_api_delegate_type_id__volatile = 0;
	if (g_once_init_enter (&valadoc_api_delegate_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValadocApiDelegateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) valadoc_api_delegate_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValadocApiDelegate), 0, (GInstanceInitFunc) valadoc_api_delegate_instance_init, NULL };
		static const GInterfaceInfo valadoc_api_callable_info = { (GInterfaceInitFunc) valadoc_api_delegate_valadoc_api_callable_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType valadoc_api_delegate_type_id;
		valadoc_api_delegate_type_id = g_type_register_static (VALADOC_API_TYPE_TYPESYMBOL, "ValadocApiDelegate", &g_define_type_info, 0);
		g_type_add_interface_static (valadoc_api_delegate_type_id, VALADOC_API_TYPE_CALLABLE, &valadoc_api_callable_info);
		g_once_init_leave (&valadoc_api_delegate_type_id__volatile, valadoc_api_delegate_type_id);
	}
	return valadoc_api_delegate_type_id__volatile;
}


static void
_vala_valadoc_api_delegate_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	ValadocApiDelegate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_DELEGATE, ValadocApiDelegate);
	switch (property_id) {
		case VALADOC_API_DELEGATE_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY:
		g_value_set_string (value, valadoc_api_callable_get_implicit_array_length_cparameter_name ((ValadocApiCallable*) self));
		break;
		case VALADOC_API_DELEGATE_RETURN_TYPE_PROPERTY:
		g_value_set_object (value, valadoc_api_callable_get_return_type ((ValadocApiCallable*) self));
		break;
		case VALADOC_API_DELEGATE_NODE_TYPE_PROPERTY:
		g_value_set_enum (value, valadoc_api_node_get_node_type ((ValadocApiNode*) self));
		break;
		case VALADOC_API_DELEGATE_IS_STATIC_PROPERTY:
		g_value_set_boolean (value, valadoc_api_delegate_get_is_static (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void
_vala_valadoc_api_delegate_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	ValadocApiDelegate * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, VALADOC_API_TYPE_DELEGATE, ValadocApiDelegate);
	switch (property_id) {
		case VALADOC_API_DELEGATE_IMPLICIT_ARRAY_LENGTH_CPARAMETER_NAME_PROPERTY:
		valadoc_api_callable_set_implicit_array_length_cparameter_name ((ValadocApiCallable*) self, g_value_get_string (value));
		break;
		case VALADOC_API_DELEGATE_RETURN_TYPE_PROPERTY:
		valadoc_api_callable_set_return_type ((ValadocApiCallable*) self, g_value_get_object (value));
		break;
		case VALADOC_API_DELEGATE_IS_STATIC_PROPERTY:
		valadoc_api_delegate_set_is_static (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



